searchNodes=[{"doc":"Localized metrics reporter","ref":"Mobius.html","title":"Mobius","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mobius.html#child_spec/1","title":"Mobius.child_spec/1","type":"function"},{"doc":"Get the current metric information If you configured Mobius to use a different name then you can pass in your custom name to ensure Mobius requests the metrics from the right place.","ref":"Mobius.html#info/1","title":"Mobius.info/1","type":"function"},{"doc":"","ref":"Mobius.html#last_ts/1","title":"Mobius.last_ts/1","type":"function"},{"doc":"Plot the metric name to the screen If there are tags for the metric you can pass those in the second argument: Mobius.Charts . plot ( &quot;vm.memory.total&quot; , %{ some : :tag } ) By default the plot will display the last 3 minutes of metric history. However, you can pass the :from and :to options to look at a specific range of time. Mobius . plot ( &quot;vm.memory.total&quot; , %{ } , from : 1630619212 , to : 1630619219 ) You can also plot data over the last x amount of time. Where x is an integer. When there is no time_unit() provided the unit is assumed to be :second . Plotting data over the last 30 seconds: Mobius . plot ( &quot;vm.memory.total&quot; , %{ } , last : 30 ) Plotting data over the last 2 hours: Mobius . plot ( &quot;vm.memory.total&quot; , %{ } , last : { 2 , :hour } )","ref":"Mobius.html#plot/3","title":"Mobius.plot/3","type":"function"},{"doc":"","ref":"Mobius.html#query_opts/1","title":"Mobius.query_opts/1","type":"function"},{"doc":"Start Mobius","ref":"Mobius.html#start_link/1","title":"Mobius.start_link/1","type":"function"},{"doc":"Produces a CSV of currently collected metrics, optionally writing the CSV to file. The CSV looks like: timestamp, name, type, value, tag1, tag2, tag3..., tagN If tags are provided, only the metrics matching the tags are output to the CSV. If a writable file is given via the :file option, the CSV is written to it. Otherwise it is written to the terminal. If the optional :naming option contains :csv_ext, the .csv extension is added to the file name if not already present. If the optional :naming option list :timestamp, the file name is prefixed by a timestamp. Just as with plotting, metrics to be outputted to CSV can be restricted to a relative time period: :last - metrics captured over the last x amount of time. Where x is either an integer or a tuple of {integer(), time_unit()} . If you only pass an integer the time unit of :seconds is assumed. By default the last 3 minutes of data will be outputted. :from - the unix timestamp, in seconds, to start querying from :to - the unix timestamp, in seconds, to stop querying at If a metric has multiple types, a CSV can filter on one type with option type: :sum or type: :last_value etc.. Examples: iex&gt; Mobius.to_csv(&quot;vm.memory.total&quot;, %{}) -- writes CSV values to the terminal iex&gt; Mobius.to_csv(&quot;vm.memory.total&quot;, %{}, file: &quot;/data/csv/vm.memory.total&quot;) -- writes CSV values to file vm.memory.total iex&gt; Mobius.to_csv(&quot;vm.memory.total&quot;, %{}, file: &quot;/data/csv/vm.memory.total&quot;, naming: [:csv_ext, :timestamp]) -- writes CSV values to a file like 20210830T174954_vm.memory.total.csv iex&gt; Mobius.to_csv(&quot;vm.memory.total&quot;, %{}) -- writes CSV values to the terminal iex&gt; Mobius.to_csv(&quot;vintage_net_qmi.connection.end.duration&quot;, %{ifname: &quot;wwan0&quot;, status: :disconnected}, type: :sum, last: {60, :day}) -- writes CSV values to the terminal","ref":"Mobius.html#to_csv/3","title":"Mobius.to_csv/3","type":"function"},{"doc":"Arguments to Mobius :name - the name of the mobius instance (defaults to :mobius ) :metrics - list of telemetry metrics for Mobius to track :persistence_dir - the top level directory where mobius will persist metric information :day_count - number of day-granularity samples to keep :hour_count - number of hour-granularity samples to keep :minute_count - number of minute-granularity samples to keep :second_count - number of second-granularity samples to keep","ref":"Mobius.html#t:arg/0","title":"Mobius.arg/0","type":"type"},{"doc":"","ref":"Mobius.html#t:csv_opt/0","title":"Mobius.csv_opt/0","type":"type"},{"doc":"","ref":"Mobius.html#t:metric_name/0","title":"Mobius.metric_name/0","type":"type"},{"doc":"","ref":"Mobius.html#t:metric_type/0","title":"Mobius.metric_type/0","type":"type"},{"doc":"The name of the Mobius instance This is used to store data for a particular set of mobius metrics.","ref":"Mobius.html#t:name/0","title":"Mobius.name/0","type":"type"},{"doc":"","ref":"Mobius.html#t:naming_opt/0","title":"Mobius.naming_opt/0","type":"type"},{"doc":"Options to use when plotting time series metric data :name - the name of the Mobius instance you are using. Unless you specified this in your configuration you should be safe to allow this option to default, which is :mobius_metrics . :last - display data point that have been captured over the last x amount of time. Where x is either an integer or a tuple of {integer(), time_unit()} . If you only pass an integer the time unit of :seconds is assumed. By default Mobius will plot the last 3 minutes of data. :from - the unix timestamp, in seconds, to start querying from :to - the unix timestamp, in seconds, to stop querying at :type - for metrics that have different types of measurements, you can pass this option to filter which metric type you want to plot","ref":"Mobius.html#t:plot_opt/0","title":"Mobius.plot_opt/0","type":"type"},{"doc":"","ref":"Mobius.html#t:time_unit/0","title":"Mobius.time_unit/0","type":"type"},{"doc":"Mobius Library for localized telemetry metrics","ref":"readme.html","title":"Mobius","type":"extras"},{"doc":"def deps do [ { :mobius , &quot;~&gt; 0.3.2&quot; } ] end","ref":"readme.html#installation","title":"Mobius - Installation","type":"extras"},{"doc":"Add Mobius to your supervision tree and pass in the metrics you want to track. def start ( _type , _args ) do metrics = [ Metrics . last_value ( &quot;my.telemetry.event&quot; ) , ] children = [ # ... other children .... { Mobius , metrics : metrics } # ... other children .... ] # See https://hexdocs.pm/elixir/Supervisor.html # for other strategies and supported options opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end Configure persistence directory By default Mobius will try to save metric data for all resolutions and the current value when the erlang system exists gracefully. This makes Mobius useful for Nerves devices that have to reboot after doing a planned firmware update. The default direction Mobius will try to persist data to is the /data directory as this is friendly to Nerves devices. If you want Mobius to store data in a different location you can pass that into Mobius when you start it: children = [ # ... other children ... { Mobius , metrics : metrics , persistence_dir : &quot;/tmp&quot; } # ... other children ... ] Charting historical metrics Mobius tracks metrics overtime in a circular buffer and allows you to graph metric values over time using Mobius.Charts.plot/3 : iex&gt; Mobius.Charts . plot ( &quot;vm.memory.total&quot; ) Metric Name : vm . memory . total , Tags : %{ } 34355808.00 ┤ 34253736.73 ┤ ╭ ─ ─ ╮ ╭ ─ ─ ─ ─ ╮ 34151665.45 ┤ ╭ ─ ─ ─ ─ ╯ ╰ ─ ─ ─ ─ ╯ ╰ ─ ─ ─ 34049594.18 ┤ ╭ ─ ─ ─ ─ ╮ ╭ ─ ─ ─ ─ ╮ ╭ ─ ─ ─ ─ ╯ 33947522.91 ┤ │ ╰ ─ ─ ─ ─ ╯ ╰ ─ ╯ 33845451.64 ┤ │ 33743380.36 ┤ ╭ ─ ─ ─ ─ ╯ 33641309.09 ┤ │ 33539237.82 ┤ │ 33437166.55 ┤ │ 33335095.27 ┼ ─ ─ ─ ─ ╯ Printing current metrics To see the current metrics you can use Mobius.Charts.info/0 : iex&gt; Mobius.Charts . info ( ) Event : vintage_net_qmi . connection . end . duration Tags : %{ ifname : &quot;wwan0&quot; , status : :lan } counter : 4 last_value : 310000 Event : vm . memory . total Tags : %{ } last_value : 34674312","ref":"readme.html#usage","title":"Mobius - Usage","type":"extras"},{"doc":"Changelog This project follows Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Added Support for Telemetry.Metrics.Sum type Support for filtering CSV records by type with :type option","ref":"changelog.html#v0-3-2-2021-09-22","title":"Changelog - v0.3.2 - 2021-09-22","type":"extras"},{"doc":"Added Plot over the last x seconds via the :last plot option Plot from an absolute time via the :from plot option Plot to an absolute time via the :to plot option Print or save metric time series via Mobius.to_csv/3 Remove tracking a metric by dropping it from the metric list passed to Mobius Changed Mobius.plot/3 will only show the last 3 minutes of data by default","ref":"changelog.html#v0-3-1-2021-09-08","title":"Changelog - v0.3.1 - 2021-09-08","type":"extras"},{"doc":"Changed Deleted Mobius.Charts module. The functions in this module are now located in the Mobius module. Removed Support for specifying resolutions.","ref":"changelog.html#v0-3-0-2021-8-19","title":"Changelog - v0.3.0 - 2021-8-19","type":"extras"},{"doc":"Added Mobius.Charts module Persistence of historical information on graceful shutdown Ability to specify time resolutions for plots Changed Move Moblus.plot/0 and Mobius.info/0 to Mobius.Charts module","ref":"changelog.html#v0-2-0-2021-8-03","title":"Changelog - v0.2.0 - 2021-8-03","type":"extras"},{"doc":"Initial release!","ref":"changelog.html#v0-1-0-2021-7-16","title":"Changelog - v0.1.0 - 2021-7-16","type":"extras"}]